{{
gui_button.spin: - Defines a gui button
Copyright (c) 2009 John Steven Denson
See MIT license terms below
}}

var
  long textptr
  word left
  word top
  word width
  word height
  word clicked
  word deflt
  word m3d
  word m3dok
  word bgcolor
  word fgcolor
  word face3d[150]
  
obj d: "spiasm-lcd-65k"
    g: "gui_common"

pub init(tp,x,y,w,h)
{{
  button constructor
  @param tp - pointer to button text
  @param x  - left
  @param y  - top
  @param w  - width  use 0 for autosize
  @param h  - height use 0 for autosize
}}
  left  := x
  top   := y
  ifnot w
    width := strsize(tp)*constant(d#FONTWIDTH+2)
  else
    width := w
  ifnot h
    height := g#DHEIGHT
  else
    height:= h
  textptr := tp
  m3dok := false
  set3dmode(true)
  setbgcolor(d#TRANSPARENT)
  setfgcolor(d#NAVY)
  setDefault(false)
  setClick(false)

pub setClick(v)
  clicked := v  

pub getClick
  return clicked

pub setDefault(v)
  deflt := v  

pub getDefault
  return deflt

pub set3dMode(v) | n, lev, dec
  m3d := v
  if m3d and m3dok == 0
    m3dok := true
    ifnot bgcolor
      lev := %11111_111111_11111 ' 65k color 5:6:5 format
    else
      lev := bgcolor
    dec := %00001_000010_00001 ' 65k color 5:6:5 format
    repeat n from 0 to height-1
      ifnot n // 2 or n == height/2
        lev-=dec
      face3d[n] := lev

pub get3dMode
  return m3d

pub setText(v)
  textptr := v

pub setTop(v)
  top := v
  
pub setLeft(v)
  left := v

pub setWidth(v)
  width := v

pub setHeight(v)
  top := v
  m3dok := false

pub setBgColor(v)  
  bgcolor := v  
  m3dok := false
  
pub setFgColor(v)  
  fgcolor := v  
  
pub getText
  return textptr

pub getTop
  return top
  
pub getLeft
  return left

pub getWidth
  return width

pub getHeight
  return height

pub getBgColor  
  return bgcolor  
  
pub getFgColor  
  return fgcolor  

pub paint | n

  if m3d
  
    if clicked
      repeat n from 0 to height-1
        d.fillRectangle(face3d[height-n],left,top+n,width,1)
      d.drawRectangle(d#LIGHT_GRAY,left,top,width,height,1)
    else
      repeat n from 0 to height-1
        d.fillRectangle(face3d[n],left,top+n,width,1)
      d.drawRectangle(d#LIGHT_GRAY,left,top,width,height,1)
      
    if deflt
      d.drawRectangle(d#BLUE,left+1,top+1,width-2,height-1,1)
    else
      d.drawRectangle(d#WHITE_GRAY,left+1,top+1,width-2,height-1,1)
      
  else  

    ifnot bgcolor
      if clicked
        d.fillRectangle(d#WHITEST_GRAY,left,top,width,height)
      else
        d.fillRectangle(d#WHITE_GRAY,left,top,width,height)
    else
      if clicked
        d.fillRectangle(bgcolor,left,top,width,height)
      else
        d.fillRectangle(d#WHITE_GRAY,left,top,width,height)

    d.drawRectangle(d#DARK_GRAY,left,top,width,height,1)
    if deflt
      d.drawRectangle(d#BLUE,left+1,top+1,width-2,height-1,1)
    else
      d.drawRectangle(d#LIGHT_GRAY,left+1,top+1,width-2,height-1,1)
      
  d.setbgcolor(bgcolor)
  d.setfgcolor(fgcolor)
  d.drawString(textptr,left+constant(d#FONTWIDTH*3/2),top+constant(d#FONTHEIGHT*2/3))

pub click
  clicked~~
  paint
  waitcnt(clkfreq/10+cnt)
  clicked~
  paint

{{
                            TERMS OF USE: MIT License                                                           

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
        