{{
gui_textbox.spin: - Defines a gui textbox
Copyright (c) 2009 John Steven Denson
See MIT license terms below
}}

var
  long textptr                  '' pointer to textbox text
  long left                     '' left pixel position of element
  long top                      '' top pixel position of element
  long width                    '' pixel width of element -- set to 0 for default or auto size
  long height                   '' pixel height of element -- set to 0 for default or auto size
  long bgcolor                  '' bgcolor for textbox
  long fgcolor                  '' fgcolor for texttbox
  long highlight                '' highlight color for cursor
  long cindex                   '' cursor index for texttbox -- -1 for no cursor

obj d: "spiasm-lcd-65k"
    g: "gui_common"
    
pub init(textp,x,y,w,h)
{{
  listbox constructor - creates a proportionally spaced list of count text boxes in given width/height
  @param textp  - pointer to text
  @param x  - left
  @param y  - top
  @param w  - width  use 0 for default size
  @param h  - height use 0 for default size
}}
  textptr := textp
  left  := x
  top   := y
  ifnot w
    width := strsize(textptr)*constant(d#FONTWIDTH+2)
  else
    width := w
  ifnot h
    height := g#DHEIGHT
  else
    height:= h
  setbgcolor(d#TRANSPARENT)
  setfgcolor(d#BLACK)
  setCursor(-1) ' no cursor
  setHighlight(d#WHITE_GRAY)   

pub setCharAt(n,v)
'  cindex := n
  ifnot v
    v := " "
  byte[textptr+n] := v

pub getCharAt(n)
  return byte[textptr+n]

pub setCursor(n)
  cindex := n

pub getCursor(n)
  return cindex
    
pub setHighlight(v)
  highlight := v

pub getHighlight
  return highlight

pub setText(v)
  textptr := v

pub setTop(v)
  top := v
  
pub setLeft(v)
  left := v

pub setWidth(v)
  width := v

pub setHeight(v)
  height := v

pub setBgColor(v)  
  bgcolor := v  
  
pub setFgColor(v)  
  fgcolor := v  
  
pub getText
  return textptr

pub getTop
  return top
  
pub getLeft
  return left

pub getWidth
  return width

pub getHeight
  return height

pub getBgColor  
  return bgcolor  
  
pub getFgColor  
  return fgcolor  
  
pub paint | n, h
  d.setbgcolor(bgcolor)
  d.setfgcolor(fgcolor)
  ifnot bgcolor
    d.fillRectangle(d#WHITE,left,top,width,height)
  else
    d.fillRectangle(bgcolor,left,top,width,height)
  
  d.drawRectangle(d#LIGHT_GRAY,left,top,width-1,height-1,1)
  d.drawRectangle(d#DARK_GRAY,left+1,top+1,width-2,height-2,1)
  d.drawRectangle(d#WHITE_GRAY,left+2,top+2,width-4,height-4,1)
  if textptr
    d.drawString(textptr,left+d#FONTWIDTH,top+constant(d#FONTHEIGHT*2/3))
  
  if cindex > -1
    d.dispChar(byte[textptr+cindex],fgcolor, highlight, left+d#FONTWIDTH*(cindex+1),top+constant(d#FONTHEIGHT*2/3))
    d.setbgcolor(bgcolor)       ' make sure bgcolor goes back to normal
    
   
{{
                            TERMS OF USE: MIT License                                                           

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
      